# Access Methods

## The access\_method Object

* [Properties](#properties)
* [Warnings](#warnings)
* [Events](#events)
* [Endpoints](#endpoints)

Represents an access method for an Access Grant. Access methods describe the modes of access, such as PIN codes, plastic cards, and mobile keys. For a mobile key, the access method also stores the URL for the associated Instant Key.

{% tabs %}
{% tab title="Card Access Method" %}
A card access method resource.

```json
{
  "access_method_id": "27d8ad77-55c2-4e20-b5b3-43555926f0e8",
  "created_at": "2025-06-14T16:54:17.946612Z",
  "display_name": "My Card",
  "is_card_encoding_required": true,
  "issued_at": "2025-06-14T16:54:17.946612Z",
  "mode": "card",
  "workspace_id": "661025d3-c1d2-403c-83a8-af153aaedfbc"
}
```

{% endtab %}

{% tab title="Mobile Key Access Method" %}
A mobile key access method resource.

```json
{
  "access_method_id": "27d8ad77-55c2-4e20-b5b3-43555926f0e8",
  "created_at": "2025-06-14T16:54:17.946612Z",
  "display_name": "My Mobile Key",
  "instant_key_url": "https://ik.seam.co/ABCXYZ",
  "is_card_encoding_required": false,
  "mode": "mobile_key",
  "workspace_id": "661025d3-c1d2-403c-83a8-af153aaedfbc"
}
```

{% endtab %}

{% tab title="PIN Code Access Method" %}
A PIN code access method resource.

```json
{
  "access_method_id": "27d8ad77-55c2-4e20-b5b3-43555926f0e8",
  "created_at": "2025-06-14T16:54:17.946612Z",
  "display_name": "My PIN Code",
  "is_card_encoding_required": false,
  "mode": "code",
  "workspace_id": "661025d3-c1d2-403c-83a8-af153aaedfbc"
}
```

{% endtab %}
{% endtabs %}

***

## Properties

**`access_method_id`** *UUID*

ID of the access method.

***

**`client_session_token`** *String*

Token of the client session associated with the access method.

***

**`code`** *String*

The actual PIN code for code access methods.

***

**`created_at`** *Datetime*

Date and time at which the access method was created.

***

**`customization_profile_id`** *UUID*

ID of the customization profile associated with the access method.

***

**`display_name`** *String*

Display name of the access method.

***

**`instant_key_url`** *String*

URL of the Instant Key for mobile key access methods.

***

**`is_encoding_required`** *Boolean*

Indicates whether encoding with an card encoder is required to issue or reissue the plastic card associated with the access method.

***

**`is_issued`** *Boolean*

Indicates whether the access method has been issued.

***

**`is_ready_for_encoding`** *Boolean*

Indicates whether the access method is ready to be encoded. This is true when the credential has been created and the card has not yet been issued.

***

**`issued_at`** *Datetime*

Date and time at which the access method was issued.

***

**`mode`** *Enum*

Access method mode. Supported values: `code`, `card`, `mobile_key`, `cloud_key`.

<details>

<summary>Enum values</summary>

* `code`
* `card`
* `mobile_key`
* `cloud_key`

</details>

***

**`pending_mutations`** *List* *of Objects*

Pending mutations for the [access method](https://docs.seam.co/latest/capability-guides/access-grants/delivering-access-methods). Indicates operations that are in progress.

The specific structure of each object in this list depends on the value of its `mutation_code` field.

Variants:

<details>

<summary><code>provisioning_access</code></summary>

Seam is in the process of provisioning access for this access method on new devices.

**`created_at`** *Datetime*

Date and time at which the mutation was created.

***

**`from`** *Object*

Previous device configuration.

Child Properties

* **`device_ids`** *List* *of UUIDs*

  Previous device IDs where access was provisioned.

***

**`message`** *String*

Detailed description of the mutation.

***

**`mutation_code`** *Enum*

Mutation code to indicate that Seam is in the process of provisioning access for this access method on new devices.

Enum values:

* `provisioning_access`

***

**`to`** *Object*

New device configuration.

Child Properties

* **`device_ids`** *List* *of UUIDs*

  New device IDs where access is being provisioned.

</details>

<details>

<summary><code>revoking_access</code></summary>

Seam is in the process of revoking access for this access method from devices.

**`created_at`** *Datetime*

Date and time at which the mutation was created.

***

**`from`** *Object*

Previous device configuration.

Child Properties

* **`device_ids`** *List* *of UUIDs*

  Previous device IDs where access existed.

***

**`message`** *String*

Detailed description of the mutation.

***

**`mutation_code`** *Enum*

Mutation code to indicate that Seam is in the process of revoking access for this access method from devices.

Enum values:

* `revoking_access`

***

**`to`** *Object*

New device configuration.

Child Properties

* **`device_ids`** *List* *of UUIDs*

  New device IDs where access should remain.

</details>

<details>

<summary><code>updating_access_times</code></summary>

Seam is in the process of updating the access times for this access method.

**`created_at`** *Datetime*

Date and time at which the mutation was created.

***

**`from`** *Object*

Previous access time configuration.

Child Properties

* **`ends_at`** *Datetime*

  Previous end time for access.
* **`starts_at`** *Datetime*

  Previous start time for access.

***

**`message`** *String*

Detailed description of the mutation.

***

**`mutation_code`** *Enum*

Mutation code to indicate that Seam is in the process of updating the access times for this access method.

Enum values:

* `updating_access_times`

***

**`to`** *Object*

New access time configuration.

Child Properties

* **`ends_at`** *Datetime*

  New end time for access.
* **`starts_at`** *Datetime*

  New start time for access.

</details>

***

[**`warnings`**](#warnings) *List* *of Objects*

Warnings associated with the [access method](https://docs.seam.co/latest/capability-guides/access-grants/delivering-access-methods).

The specific structure of each object in this list depends on the value of its `warning_code` field.

Variants:

<details>

<summary><code>being_deleted</code></summary>

Indicates that the [access method](https://docs.seam.co/latest/capability-guides/access-grants/delivering-access-methods) is being deleted.

**`created_at`** *Datetime*

Date and time at which Seam created the warning.

***

**`message`** *String*

Detailed description of the warning. Provides insights into the issue and potentially how to rectify it.

***

**`warning_code`** *Enum*

Unique identifier of the type of warning. Enables quick recognition and categorization of the issue.

Enum values:

* `being_deleted`

</details>

<details>

<summary><code>updating_access_times</code></summary>

Indicates that the access times for this [access method](https://docs.seam.co/latest/capability-guides/access-grants/delivering-access-methods) are being updated.

**`created_at`** *Datetime*

Date and time at which Seam created the warning.

***

**`message`** *String*

Detailed description of the warning. Provides insights into the issue and potentially how to rectify it.

***

**`warning_code`** *Enum*

Unique identifier of the type of warning. Enables quick recognition and categorization of the issue.

Enum values:

* `updating_access_times`

</details>

<details>

<summary><code>pulled_backup_access_code</code></summary>

Indicates that all attempts to create an access code on this device before the start time failed and a backup access code was used to ensure access was provided in time.

**`created_at`** *Datetime*

Date and time at which Seam created the warning.

***

**`message`** *String*

Detailed description of the warning. Provides insights into the issue and potentially how to rectify it.

***

**`original_access_method_id`** *UUID*

ID of the original access method from which this backup access method was split, if applicable.

***

**`warning_code`** *Enum*

Unique identifier of the type of warning. Enables quick recognition and categorization of the issue.

Enum values:

* `pulled_backup_access_code`

</details>

***

**`workspace_id`** *UUID*

ID of the Seam workspace associated with the access method.

***

## Warnings

**`being_deleted`**

Indicates that the [access method](https://docs.seam.co/latest/capability-guides/access-grants/delivering-access-methods) is being deleted.

***

**`pulled_backup_access_code`**

Indicates that all attempts to create an access code on this device before the start time failed and a backup access code was used to ensure access was provided in time.

***

**`updating_access_times`**

Indicates that the access times for this [access method](https://docs.seam.co/latest/capability-guides/access-grants/delivering-access-methods) are being updated.

***

## Events

**`access_method.issued`**

An access method was issued.

<details>

<summary>Properties</summary>

**`access_grant_ids`** *List* *of UUIDs*

IDs of the access grants associated with this access method.

**`access_grant_keys`** *List* *of Strings*

Keys of the access grants associated with this access method (if present).

**`access_method_id`** *UUID*

ID of the affected access method.

**`code`** *String*

The actual PIN code for code access methods (only present when mode is 'code').

**`created_at`** *Datetime*

Date and time at which the event was created.

**`event_id`** *UUID*

ID of the event.

**`event_type`** *Enum*

Value: `access_method.issued`

**`is_backup_code`** *Boolean*

Indicates whether the code is a backup code (only present when mode is 'code' and a backup code was used).

**`occurred_at`** *Datetime*

Date and time at which the event occurred.

**`workspace_id`** *UUID*

ID of the [workspace](https://docs.seam.co/latest/core-concepts/workspaces) associated with the event.

</details>

***

**`access_method.revoked`**

An access method was revoked.

<details>

<summary>Properties</summary>

**`access_grant_ids`** *List* *of UUIDs*

IDs of the access grants associated with this access method.

**`access_grant_keys`** *List* *of Strings*

Keys of the access grants associated with this access method (if present).

**`access_method_id`** *UUID*

ID of the affected access method.

**`created_at`** *Datetime*

Date and time at which the event was created.

**`event_id`** *UUID*

ID of the event.

**`event_type`** *Enum*

Value: `access_method.revoked`

**`occurred_at`** *Datetime*

Date and time at which the event occurred.

**`workspace_id`** *UUID*

ID of the [workspace](https://docs.seam.co/latest/core-concepts/workspaces) associated with the event.

</details>

***

**`access_method.card_encoding_required`**

An access method representing a physical card requires encoding.

<details>

<summary>Properties</summary>

**`access_grant_ids`** *List* *of UUIDs*

IDs of the access grants associated with this access method.

**`access_grant_keys`** *List* *of Strings*

Keys of the access grants associated with this access method (if present).

**`access_method_id`** *UUID*

ID of the affected access method.

**`created_at`** *Datetime*

Date and time at which the event was created.

**`event_id`** *UUID*

ID of the event.

**`event_type`** *Enum*

Value: `access_method.card_encoding_required`

**`occurred_at`** *Datetime*

Date and time at which the event occurred.

**`workspace_id`** *UUID*

ID of the [workspace](https://docs.seam.co/latest/core-concepts/workspaces) associated with the event.

</details>

***

**`access_method.deleted`**

An access method was deleted.

<details>

<summary>Properties</summary>

**`access_grant_ids`** *List* *of UUIDs*

IDs of the access grants associated with this access method.

**`access_grant_keys`** *List* *of Strings*

Keys of the access grants associated with this access method (if present).

**`access_method_id`** *UUID*

ID of the affected access method.

**`created_at`** *Datetime*

Date and time at which the event was created.

**`event_id`** *UUID*

ID of the event.

**`event_type`** *Enum*

Value: `access_method.deleted`

**`occurred_at`** *Datetime*

Date and time at which the event occurred.

**`workspace_id`** *UUID*

ID of the [workspace](https://docs.seam.co/latest/core-concepts/workspaces) associated with the event.

</details>

***

**`access_method.reissued`**

An access method was reissued.

<details>

<summary>Properties</summary>

**`access_grant_ids`** *List* *of UUIDs*

IDs of the access grants associated with this access method.

**`access_grant_keys`** *List* *of Strings*

Keys of the access grants associated with this access method (if present).

**`access_method_id`** *UUID*

ID of the affected access method.

**`code`** *String*

The actual PIN code for code access methods (only present when mode is 'code').

**`created_at`** *Datetime*

Date and time at which the event was created.

**`event_id`** *UUID*

ID of the event.

**`event_type`** *Enum*

Value: `access_method.reissued`

**`is_backup_code`** *Boolean*

Indicates whether the code is a backup code (only present when mode is 'code' and a backup code was used).

**`occurred_at`** *Datetime*

Date and time at which the event occurred.

**`workspace_id`** *UUID*

ID of the [workspace](https://docs.seam.co/latest/core-concepts/workspaces) associated with the event.

</details>

***

**`access_method.created`**

An access method was created.

<details>

<summary>Properties</summary>

**`access_grant_ids`** *List* *of UUIDs*

IDs of the access grants associated with this access method.

**`access_grant_keys`** *List* *of Strings*

Keys of the access grants associated with this access method (if present).

**`access_method_id`** *UUID*

ID of the affected access method.

**`created_at`** *Datetime*

Date and time at which the event was created.

**`event_id`** *UUID*

ID of the event.

**`event_type`** *Enum*

Value: `access_method.created`

**`occurred_at`** *Datetime*

Date and time at which the event occurred.

**`workspace_id`** *UUID*

ID of the [workspace](https://docs.seam.co/latest/core-concepts/workspaces) associated with the event.

</details>

***

## Endpoints

[**`/access_methods/delete`**](/latest/api/access_methods/delete.md)

Deletes an access method.

[**`/access_methods/encode`**](/latest/api/access_methods/encode.md)

Encodes an existing access method onto a plastic card placed on the specified [encoder](https://docs.seam.co/latest/capability-guides/access-systems/working-with-card-encoders-and-scanners).

[**`/access_methods/get`**](/latest/api/access_methods/get.md)

Gets an access method.

[**`/access_methods/get_related`**](/latest/api/access_methods/get_related.md)

Gets all related resources for one or more Access Methods.

[**`/access_methods/list`**](/latest/api/access_methods/list.md)

Lists all access methods, usually filtered by Access Grant.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.seam.co/latest/api/access_methods.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
